SystemOrganization addCategory: #ConfigurationOfTuio!

Object subclass: #ConfigurationOfTuio
	instanceVariableNames: 'project'
	classVariableNames: 'LastVersionLoad'
	poolDictionaries: ''
	category: 'ConfigurationOfTuio'!

!ConfigurationOfTuio commentStamp: 'StephaneDucasse 10/1/2012 10:29' prior: 0!
(ConfigurationOfTuio project version: #stable) load

!

!ConfigurationOfTuio class methodsFor: 'private' stamp: ''!
bootstrapPackage: aString from: aPath 
	| repository version |
	repository := MCHttpRepository
				location: aPath
				user: ''
				password: ''.
	repository
		versionReaderForFileNamed: aString , '.mcz'
		do: [:reader | 
			version := reader version.
			version load.
			version workingCopy repositoryGroup addRepository: repository]! !

!ConfigurationOfTuio class methodsFor: 'private' stamp: ''!
ensureMetacello
	"Bootstrap Gofer (if necessary), bootstrap ConfigurationOfMetacello (using old Gofer API), then load the latest 
	version of Metacello itself."

	Smalltalk globals at: #MetacelloProject ifAbsent: [
		Smalltalk globals at: #Gofer ifAbsent: [
			"Current version of Gofer from which to bootstrap - as of 1.0-beta.15"
			self bootstrapPackage: 'Gofer-lr.83' from: 'http://seaside.gemstone.com/ss/metacello' ].
		Smalltalk globals at: #Gofer ifPresent: [:goferClass | | gofer |
			gofer := goferClass new
				url: 'http://seaside.gemstone.com/ss/metacello';
				yourself.
			[ gofer addPackage: 'ConfigurationOfMetacello' ] on: Warning do: [:ex | ex resume ].
			gofer load ].
		"load latest version of Metacello, load a specific version if desired"
		(Smalltalk at: #ConfigurationOfMetacello) perform: #loadLatestVersion ]! !

!ConfigurationOfTuio class methodsFor: 'metacello tool support' stamp: ''!
isMetacelloConfig
	"Answer true and the Metacello tools will operate on you"
	
	^true! !

!ConfigurationOfTuio class methodsFor: 'metacello tool support' stamp: ''!
lastMetacelloVersionLoad
	"Answer the last version loaded and the list of packages loaded for that version."

	LastVersionLoad == nil ifTrue: [ LastVersionLoad := nil -> 'default' ].
	^LastVersionLoad! !

!ConfigurationOfTuio class methodsFor: 'metacello tool support' stamp: ''!
metacelloVersion: versionString loads: anArrayOrString
	"Stash the last version loaded and the list of packages loaded for that version. The list
	 of packages will be used by the tools when doing 'Load Package Version'"

	LastVersionLoad := versionString -> anArrayOrString! !

!ConfigurationOfTuio class methodsFor: 'accessing' stamp: ''!
project

	^self new project! !

!ConfigurationOfTuio methodsFor: 'baselines' stamp: 'StephaneDucasse 10/1/2012 10:00'!
baseline10: spec 
	<version: '1.0-baseline'>

	spec for: #pharo do: [
		spec blessing: #baseline.
		spec repository: 'http://smalltalkhub.com/mc/StephaneDucasse/Tuio/main'.
		spec project: 'OSC' with: [
				spec
					className: 'ConfigurationOfOSC';
					loads: #('Core' );
					repository: 'http://smalltalkhub.com/mc/StephaneDucasse/OSC/main' ].
		spec 
			package: 'Tuio' with: [ spec requires: 'OSC' ].
			
		spec 
			group: 'default' with: #('Core');
			group: 'Core' with: #('Tuio');
			yourself.
		].! !

!ConfigurationOfTuio methodsFor: 'accessing' stamp: ''!
project

	^ project ifNil: [ | constructor |
		"Bootstrap Metacello if it is not already loaded"
		self class ensureMetacello.
		"Construct Metacello project"
		constructor := (Smalltalk globals at: #MetacelloVersionConstructor) on: self.
		project := constructor project.
		project loadType: #linear.
		project ]! !

!ConfigurationOfTuio methodsFor: 'symbolic versions' stamp: 'StephaneDucasse 2/10/2013 15:48'!
stable: spec 
	<symbolicVersion: #stable>
	
	spec for: #'pharo1.4.x' version: '1.0'. 
	spec for: #'pharo2.x' version: '1.0'. 
! !

!ConfigurationOfTuio methodsFor: 'versions' stamp: 'StephaneDucasse 10/1/2012 10:00'!
version10: spec
	<version: '1.0' imports: #('1.0-baseline')>

	spec for: #pharo do: [
		spec blessing: #release.
		spec author: 'StephaneDucasse'.
		spec description: 'First release 1.0 of this project for Pharo '.		
		spec 
			package: 'Tuio' with: 'Tuio-StephaneDucasse.17'
			"package: 'OSC-Tests' with: 'ba'."
		].
	! !
